// CD 02/2010
// FLASHIT.c clignotement de la LED sur PB0 par interruption T=1.048s (TIMER0 produit des temps de 2expN)
// mise en oeuvre simple du TIMER 0, chaque dbordement provoque une IT.
// Le timer est en mode 16 bits avec horloge Fosc/4 soit 1MHz, prdiviseur par 8
// la priode des dbordement est donc 1uS * 8 * 65536 = 524.288 mS

#include <p18f452.h>

void traiteIT(void); 		// prototype car le vecteur est dclar avant la sp d'IT


#pragma code it=0x08		// le vecteur d'IT prioritaire envoie  l'adresse 8
							// cette pragma force le compilateur  placer le code  l'adresse indique
void saut_sur_spIT(void)	// une fonction, car en C tout est dans une fonction
{
_asm
	goto traiteIT			// saut crit en assembleur sur la fonction de traitement d'IT
_endasm
}
#pragma code				// le compilateur peut  nouveau grer les adresses


#pragma interrupt traiteIT	// traiteIT est un SP d'IT (il finit donc par retfie et non par return
void traiteIT(void)			// aucun paramtre pour un SP d'IT, son appel est asynchrone
{
	if(INTCONbits.TMR0IF)			//vrifie un dbordement sur TMR0 
			{						
			INTCONbits.TMR0IF = 0;	//efface le drapeau d'IT
			PORTBbits.RB0 = !PORTBbits.RB0;	//bascule LED sur RB0
			}
}


void main()
{
	ADCON1=0x0F;
	PORTBbits.RB0 = 0;				// port B0 en sortie
	TRISBbits.TRISB0 = 0;			// et  0
	T0CON = 0x82;					//Active le TIMER0 - prescaler 1:8
	INTCONbits.TMR0IE = 1;			//Autorise interruption sur TMR0 
	INTCONbits.GIE = 1;			//autorise toutes les IT dmasques
	
	while(1);						// une boucle infinie, tout fonctionne en IT
}
