// CD 02/10
// Test communications carte de test.

#include <p18f4620.h>

// indique qu'un caractre est dans RCREG de l'USART 
char data_recue(void)			// reception d'une interruption
{
	if (PIR1bits.RCIF)		/* char recu en reception*/
	{	
		PIR1bits.RCIF=0;	// efface drapeau
		return (1);			// indique qu'un nouveau caractre est dans RCREG
	}	
	else return (0);		// pas de nouveau caractre reu
}

// envoie un caractre sur USART
void putch(unsigned char c) 		//putch est dfini sur le port srie
{
	while(!TXSTAbits.TRMT);			// pas de transmission en cours ?
    TXREG=c;                           /* envoie un caractre */
    while(!PIR1bits.TXIF);
}



void main(void)
{
	SPBRGH= 0x00;			// SPBRG est compose de SPBRGH et SPBRG
	SPBRG = 25; 	        /* configure la vitesse (BAUD) 9600 N 8 1 (QUARTZ 4MHz)*/
    TXSTA = 0b00100000; 	                  
	RCSTA = 0b10010000;		/* active l'USART*/
	BAUDCONbits.BRG16=0;	// SPBRGH = 0 pour 9600 
	TXSTAbits.BRGH=1;		// High Speed
	putch('H');
	putch('e');
	putch('l');
	putch('l');
	putch('o');
	putch('\n');
	putch('\r');
	

    while(1)						
	    {
		     if (data_recue()) putch(RCREG+1);    // renvoie le caractre reu plus 1                              
			
    	}
}
